#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("CreateDialog");
#include "resource.h"
HWND hDlg;
COLORREF cBack=RGB(255,255,255);

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;
	
	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=(WNDPROC)WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	hWndMain=hWnd;
	
	while(GetMessage(&Message,0,0,0)) {
		if (!IsWindow(hDlg) || !IsDialogMessage(hDlg,&Message)) {
			TranslateMessage(&Message);
			DispatchMessage(&Message);
		}
	}
	return Message.wParam;
}

BOOL CALLBACK ColorDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	switch(iMessage) {
	case WM_INITDIALOG:
		return TRUE;
	case WM_COMMAND:
		switch (wParam) {
		case IDC_RED:
			cBack=RGB(255,0,0);
			break;
		case IDC_GREEN:
			cBack=RGB(0,255,0);
			break;
		case IDC_BLUE:
			cBack=RGB(0,0,255);
			break;
		case IDC_YELLOW:
			cBack=RGB(255,255,0);
			break;
		case IDC_CLOSE:
			DestroyWindow(hDlg);
			hDlg=NULL;
			return TRUE;
		}
		InvalidateRect(hWndMain,NULL,FALSE);
		return TRUE;
	}
return FALSE;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	char Mes[]=" ư = 𵨸 ȭ ȣ,  ư = ȭ ";
	RECT rt;
	HBRUSH brush,oldbrush;

	switch(iMessage) {
	case WM_LBUTTONDOWN:
		if (!IsWindow(hDlg)) {
			hDlg=CreateDialog(g_hInst,MAKEINTRESOURCE(IDD_DIALOG1),
				hWnd,ColorDlgProc);
			ShowWindow(hDlg,SW_SHOW);
		}
		return 0;
	case WM_RBUTTONDOWN:
		if (IsWindow(hDlg)) {
			DestroyWindow(hDlg);
			hDlg=NULL;
		}
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		GetClientRect(hWnd,&rt);
		brush=CreateSolidBrush(cBack);
		oldbrush=(HBRUSH)SelectObject(hdc,brush);
		FillRect(hdc,&rt,brush);
		DeleteObject(SelectObject(hdc,oldbrush));
		TextOut(hdc,10,10,Mes,lstrlen(Mes));
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
